# GUI library for MCDU. Some functions should be moved from mcdu.tcl
# to this file eventually.
# $Id: gui.tcl,v 1.8 2007/07/14 19:30:17 hoppie Exp $

# Copyright (C) 2005 Jeroen Hoppenbrouwers <hoppie@hoppie.nl>
# This program is free software; more information in the LICENSE file.


namespace eval gui {

  # Do not highlight widgets when the pointer moves over them.
  set tk_strictMotif 1

  # Position the GUI on the screen at its last coordinates, or 
  # leave its position to the window manager if they are unknown.
  set geom [prefs::get gui.position]
  if {$geom!=""} {
    wm geometry . $geom
  }

  wm title . "MCDU"
  wm protocol . WM_DELETE_WINDOW gui::done

  mcdu::init

  # Start up the MCDU.
  after 1000 {mcdu::reset}

}; # namespace gui


proc gui::done {} {
  # Quit the program after cleaning up.

  # Quit all the dependent modules.
  mcdu::done
  ps1::done
  engr::done

  # Save several preferences, flush them, and exit.
  # Only save X and Y of the top-left corner.
  set geom [wm geometry .]
  set geom [split $geom "+"]
  prefs::put gui.position "+[lindex $geom 1]+[lindex $geom 2]"

  if {[winfo exists .icon]} {
    set geom [wm geometry .icon]
    set geom [split $geom "+"]
    prefs::put icon.position "+[lindex $geom 1]+[lindex $geom 2]"
  }

  prefs::flush
  exit
}; # done
